.\"	$NetBSD: sdpquery.1,v 1.13 2009/10/06 21:39:58 wiz Exp $
.\"
.\" Copyright (c) 2006 Itronix Inc.
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. The name of Itronix Inc. may not be used to endorse
.\"    or promote products derived from this software without specific
.\"    prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY ITRONIX INC. ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL ITRONIX INC. BE LIABLE FOR ANY
.\" DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
.\" (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
.\" LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
.\" ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.\" Copyright (c) 2009 The NetBSD Foundation, Inc.
.\" Copyright (c) 2003 Maksim Yevmenkin <m_evmenkin@yahoo.com>
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\" $FreeBSD: src/usr.sbin/bluetooth/sdpcontrol/sdpcontrol.8,v 1.6 2005/07/09 19:04:43 markus Exp $
.\"
.Dd October 6, 2009
.Dt SDPQUERY 1
.Os
.Sh NAME
.Nm sdpquery
.Nd Service Discovery Protocol query utility
.Sh SYNOPSIS
.Nm
.Op Fl NRX
.Op Fl d Ar device
.Fl a Ar address
.Ar command
.Op Ar parameters ...
.Nm
.Op Fl NRX
.Op Fl c Ar path
.Fl l
.Ar command
.Op Ar parameters ...
.Sh DESCRIPTION
The
.Nm
utility attempts to query the specified Service Discovery Protocol
(SDP) server.
Remote SDP servers are identified by their address.
Connection to the local SDP server is made via the control socket.
The
.Nm
utility retrieves complete Service Records as directed and prints
each record's attribute ID/value list to standard output and error
messages to standard error.
.Pp
The options are as follows:
.Bl -tag -width ".Fl a Ar address"
.It Fl a Ar address
Connect to the remote device with the specified address.
The address can be specified as BD_ADDR or a name.
If a name was specified, the
.Nm
utility attempts to resolve the name via
.Xr bt_gethostbyname 3 .
If no remote address is given,
.Nm
attempts to contact a local SDP server via the control socket.
.It Fl c Ar path
Specify path to the control socket.
The default path is
.Pa /var/run/sdp .
.It Fl d Ar device
Connect from the local device with the specifed address.
The device can be specified by BD_ADDR or device name.
See
.Xr btconfig 8
for a list of devices available.
If no device is specified, the
.Nm
utility will use the best available.
.It Fl l
Query the local SDP server via the control socket.
.It Fl N
Additionally display numerical values.
.It Fl R
Display service attributes in raw (uninterpreted) format.
.It Fl X
Display service attribute values in hex.
.El
.Pp
The currently supported commands in
.Nm
are:
.Pp
.Bl -tag -width Browse -compact
.It Cm Browse Op Ar group
Browse for services.
The
.Ar group
parameter is the UUID of the group to browse.
If omitted, the "Public Browse Group" is used.
.Pp
.It Cm Record Ar handle Op Ar handle...
Retrieve the Service Record with the given
.Ar handle .
Multiple handles can be given.
.Pp
.It Cm Search Ar uuid Op Ar uuid...
Search for records matching the list of
UUIDs which can be given in numerical form, or the
following aliases are known:
.Pp
.Bl -tag -offset indent -compact -width RFCOMMxxx
.It A2DP
Advanced Audio Distribution Profile
.It BNEP
Bluetooth Network Encapsulation Protocol
.It CIP
Common ISDN Access Service
.It CTP
Cordless Telephony Service
.It DUN
Dialup Networking Service
.It FAX
Fax Service
.It FTRN
File Transfer Service
.It GN
Group ad-hoc Network Service
.It HID
Human Interface Device Service
.It HF
Handsfree Service
.It HSET
Headset Service
.It L2CAP
Logical Link Control and Adaptation Protocol
.It LAN
LAN Access Using PPP Service
.It NAP
Network Access Point Service
.It OBEX
Object Exchange Protocol
.It OPUSH
Object Push Service
.It PANU
Personal Area Networking User Service
.It PNP
Plug'n'Play Information Service
.It RFCOMM
RFCOMM Protocol
.It SDP
Service Discovery Protocol
.It SP
Serial Port Service
.It SYNC
IrMC Sync Client Service
.El
.Pp
Note that in order for a record to match, it must contain all the
UUIDs in the ServiceSearchPattern and the maximum number is 12.
.El
.Sh EXIT STATUS
.Ex -std
.Sh SEE ALSO
.Xr bluetooth 3 ,
.Xr sdp 3 ,
.Xr btconfig 8 ,
.Xr sdpd 8
.Sh HISTORY
The
.Nm
command first appeared in
.Fx 5.3
as
.Nm sdpcontrol .
It was ported to
.Nx 4.0
under its present name by
.An Iain Hibbert
under the sponsorship of Itronix, Inc.
.Sh AUTHORS
.An Maksim Yevmenkin Aq m_evmenkin@yahoo.com
.An Iain Hibbert
for Itronix, Inc.
